# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Empire**, the allocation and nomination platform of BritNed_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/britned/empire-platform-api) 

    The version of the OpenAPI document: 6.0.2
    Contact: britned.info@britned.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from empire_platform_api_public_client.models.border_direction import BorderDirection
from empire_platform_api_public_client.models.participant_dashboard_transmission_rights_and_nominations_data_mtus_values_nomination_restriction import ParticipantDashboardTransmissionRightsAndNominationsDataMtusValuesNominationRestriction
from typing import Optional, Set
from typing_extensions import Self

class ParticipantDashboardTransmissionRightsAndNominationsDataMtusValues(BaseModel):
    """
    ParticipantDashboardTransmissionRightsAndNominationsDataMtusValues
    """ # noqa: E501
    direction: BorderDirection
    allocated_trs: StrictInt = Field(description="Capacity value in kilowatts (kW) - the required system precision allows for handling capacity values as integers", alias="allocatedTrs")
    nominated_capacity: StrictInt = Field(description="Capacity value in kilowatts (kW) - the required system precision allows for handling capacity values as integers", alias="nominatedCapacity")
    nomination_restriction: Optional[ParticipantDashboardTransmissionRightsAndNominationsDataMtusValuesNominationRestriction] = Field(default=None, alias="nominationRestriction")
    __properties: ClassVar[List[str]] = ["direction", "allocatedTrs", "nominatedCapacity", "nominationRestriction"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ParticipantDashboardTransmissionRightsAndNominationsDataMtusValues from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of nomination_restriction
        if self.nomination_restriction:
            _dict['nominationRestriction'] = self.nomination_restriction.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ParticipantDashboardTransmissionRightsAndNominationsDataMtusValues from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "direction": obj.get("direction"),
            "allocatedTrs": obj.get("allocatedTrs"),
            "nominatedCapacity": obj.get("nominatedCapacity"),
            "nominationRestriction": ParticipantDashboardTransmissionRightsAndNominationsDataMtusValuesNominationRestriction.from_dict(obj["nominationRestriction"]) if obj.get("nominationRestriction") is not None else None
        })
        return _obj


